#ifndef __BOARD_DEF_H
#define __BOARD_DEF_H

#include <WiFi.h>
#include <BleKeyboard.h>
#include <U8g2lib.h>
#include <Arduino_GFX_Library.h>
#include <SPIFFS.h>
// https://github.com/bitbank2/PNGdec.git
#include <PNGdec.h>

#include "Button2.h"
#include <Encoder.h>


#include "fonts/Orbitron_Light_32.h"
#include "fonts/Orbitron_Light_24.h"
#include "fonts/Orbitron_Medium_16.h"
#include "fonts/Orbitron_Medium_12.h"
#include "fonts/Calligraffitti_Regular_12.h"
#include "fonts/Coming_Soon_Regular_12.h"
#include "fonts/DSEG14_Classic_Regular_40.h"


 


#define VER_HW "1.2A"
#define VER_SW "1.0.1"

#define NTP1 "ntp1.aliyun.com"
#define NTP2 "ntp2.aliyun.com"
#define NTP3 "ntp3.aliyun.com"

//wifi用户名和密码
#define ssid "xxxxxxxxxxxx" 
#define password  "xxxxxxxxxxxx" 


//天气相关
#define weather_key "xxxxxxx"//换成自己的密匙即可，需要去心知天气注册
#define weather_city "shenzhen"



#define OLED_WIDTH 96
#define OLED_HEIGHT 64

#define BUTTON1_PIN 9
#define BUTTON2_PIN 3
#define BUTTON3_PIN 2
#define BUTTON4_PIN 5

#define PIN_EC_A 21
#define PIN_EC_B 20

// disp
#define PIN_RST 10

#define PIN_MOSI 7
#define PIN_SCLK 6
#define PIN_DC 4

#define PIN_CS1 8
#define PIN_CS2 1
#define PIN_CS3 0

extern Arduino_GFX *gfx1;
extern Arduino_GFX *gfx2;
extern Arduino_GFX *gfx3;
extern Arduino_GFX *gfx[3] ;

extern BleKeyboard bleKeyboard;

extern struct tm timeInfo;

extern Button2 button1, button2, button3, button4;
extern Encoder myEnc ;

void PNGDraw1(PNGDRAW *pDraw);
void PNGDraw2(PNGDRAW *pDraw);
void PNGDraw3(PNGDRAW *pDraw);
void myDrawPNG(int16_t x, int16_t y, const char *path, uint8_t oled_index);


void board_init();




#endif
