#include "clock.h"
#include "board_def.h"
#include "app/app_key.h"
const char *number_name[] = {"zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine"};
const char *clock_name[] = {"matrix", "nixie", "vfd", "digital", "14seg", "bina", "flip", "ink", "purple", "cyan", "nimo", "wood"};
int8_t clock_type_index = 0;
bool f_updateall = false;
static uint8_t num_old[6] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
void dispTime(uint8_t hour, uint8_t min, uint8_t sec)
{
	char path[100];
	

	// gfx1->setCursor(0, 0);
	// gfx1->setTextSize(8);
	// gfx1->setTextColor(random(0xffff), BLACK);
	// gfx1->printf("%02d", hour);
	// gfx1->draw16bitBeRGBBitmap(0, -16, (uint16_t *)clock_img[hour / 10], 48, 96);
	// gfx1->draw16bitBeRGBBitmap(48, -16, (uint16_t *)clock_img[hour % 10], 48, 96);
	if (num_old[0] != hour / 10 || f_updateall)
	{
		num_old[0] = hour / 10;
		sprintf(path, "/clock_theme/%s/%s.png", clock_name[clock_type_index], number_name[hour / 10]);
		myDrawPNG(0, -16, path, 0);
	}
	if (num_old[1] != hour % 10 || f_updateall)
	{
		num_old[1] = hour % 10;
		sprintf(path, "/clock_theme/%s/%s.png", clock_name[clock_type_index], number_name[hour % 10]);
		myDrawPNG(48, -16, path, 0);
	}

	// gfx2->setCursor(0, 0);
	// gfx2->setTextSize(8);
	// gfx2->setTextColor(random(0xffff), BLACK);
	// gfx2->printf("%02d", min);
	// gfx2->draw16bitBeRGBBitmap(0, -16, (uint16_t *)clock_img[min / 10], 48, 96);
	// gfx2->draw16bitBeRGBBitmap(48, -16, (uint16_t *)clock_img[min % 10], 48, 96);
	if (num_old[2] != min / 10 || f_updateall)
	{
		num_old[2] = min / 10;
		sprintf(path, "/clock_theme/%s/%s.png", clock_name[clock_type_index], number_name[min / 10]);
		myDrawPNG(0, -16, path, 1);
	}
	if (num_old[3] != min % 10 || f_updateall)
	{
		num_old[3] = min % 10;
		sprintf(path, "/clock_theme/%s/%s.png", clock_name[clock_type_index], number_name[min % 10]);
		myDrawPNG(48, -16, path, 1);
	}

	// gfx3->setCursor(0, 0);
	// gfx3->setTextSize(8);
	// gfx3->setTextColor(random(0xffff), BLACK);
	// gfx3->printf("%02d", sec);
	// gfx3->draw16bitBeRGBBitmap(0, -16, (uint16_t *)clock_img[sec / 10], 48, 96);
	// gfx3->draw16bitBeRGBBitmap(48, -16, (uint16_t *)clock_img[sec % 10], 48, 96);
	if (num_old[4] != sec / 10 || f_updateall)
	{
		num_old[4] = sec / 10;
		sprintf(path, "/clock_theme/%s/%s.png", clock_name[clock_type_index], number_name[sec / 10]);
		myDrawPNG(0, -16, path, 2);
	}
	if (num_old[5] != sec % 10 || f_updateall)
	{
		num_old[5] = sec % 10;
		sprintf(path, "/clock_theme/%s/%s.png", clock_name[clock_type_index], number_name[sec % 10]);
		myDrawPNG(48, -16, path, 2);
	}

	f_updateall = false;
}
static void init(void *data)
{
	for (uint8_t i = 0; i < 6; i++)
	{
		num_old[i] = 0xff;
	}
}

static void enter(void *data)
{
	// insert code
	gfx1->fillScreen(BLACK);
    gfx2->fillScreen(BLACK);
    gfx3->fillScreen(BLACK);
	//
	manager_setBusy(false);
}
uint32_t t_old, t_now = 0;
uint8_t hour, minute, second = 0;
static void loop(void *data)
{
	KEY_TYPE key;

	t_now = millis();
	if (t_now - t_old >= 1000)
	{
		t_old = t_now;
		if (getLocalTime(&timeInfo))
		{

			dispTime(timeInfo.tm_hour, timeInfo.tm_min, timeInfo.tm_sec);

			// Serial.printf("%02d:%02d:%02d\r\n", timeInfo.tm_hour, timeInfo.tm_min, timeInfo.tm_sec);
		}
	}

	key = app_key_get();
	switch (key)
	{

	case KEY1_DOWN:

		break;

	case KEY4_LONG:				  //长按
		manager_switchToParent(); //进入父项目 //退出
		break;

	case ENC_NEXT:
		clock_type_index++;
	 	if(clock_type_index>=12)
		{
			clock_type_index=0;
		}
		f_updateall=true;
		dispTime(timeInfo.tm_hour, timeInfo.tm_min, timeInfo.tm_sec);
		break;
	case ENC_PREV:
		clock_type_index--;
		if(clock_type_index<0)
		{
			clock_type_index=11;
		}
		f_updateall=true;
		dispTime(timeInfo.tm_hour, timeInfo.tm_min, timeInfo.tm_sec);
		break;
	default:
		break;
	}

	
}

static void exit(void *data)
{

	manager_setBusy(true);
}
#include "img.h"
page_t page_clock = {
	.init = init,
	.enter = enter,
	.exit = exit,
	.loop = loop,
	.title_en = "Clock",
	.title_cn = "时间",
	.icon = img_bits,
	.icon_width = img_width,
	.icon_height = img_height,
	.sleep_enable = false,
	.wakeup_btn_effect_enable = false,
	.acc_enable = false,

};