#include "BluetoothSerial.h"

// Change this to match the script on the host
int redrawtime = 4000;

// The scale of the Y-axis per graph
int ymax_cpu = 110;   // In Celcius
int ymax_fan = 2000;  // In rpm
int ymax_ram = 32000; // In MB
int ymax_hdd = 250;   // In GB
int ymax_gpu = 110;   // In Celcius
int ymax_procs = 500; // In # (numbers)

// Define warning levels, change this as you like
int warn_cpu = 75;    // Higher than, in C
int warn_rpm = 7000;  // Higher than, in RPM
int warn_ram = 2000;  // Lower than, in MB
int warn_hdd = 35;    // Lower than, in GB
int warn_gpu = 70;    // Higher than, in Celcius
int warn_procs = 800; // Higher than, in #

// Place to store the last 21 readings
int32_t cpu[21] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
int32_t fan[21] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
int32_t ram[21] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
int32_t hdd[21] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
int32_t gpu[21] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
int32_t procs[21] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

// Other variables
int margin = 40;
int screenwidth = 480;
int screenheight = 320;

boolean graphshowing = false;
boolean homescreen = true;
int currentgraph = 0;
int previousmillis;

BluetoothSerial BTSerial;

void setup()
{
    // Begin BT Serial
    BTSerial.begin("MyDisplay"); // You can change this name, but on MacOs make sure to match your port to this name in the script

    // Begin regular Serial for debugging
    Serial.begin(115200);
    Serial.println("Normal Serial begun.");
}
// Function to shift all values in an array to the left and add a value
void addToArray(int32_t addvalue, int32_t *arr)
{

    for (int i = 0; i < 20; i++)
    {

        arr[i] = arr[i + 1];
    }

    arr[20] = addvalue;
}
void loop()
{

    // Some variables we need
    int t_y, t_x;
    uint16_t x, y;
    bool pressed = false;

    // Make sure we don't use last loop's touch
    pressed = false;

    // Check for incoming Serial Data
    if (BTSerial.available())
    {

        // We expect incoming data like this: "33,428,8343,16000,68,371" (temp, rpm, mem_use, free_disk, gpu, procs)
        String cpu_string = BTSerial.readStringUntil(',');
        String fan_string = BTSerial.readStringUntil(',');
        String ram_string = BTSerial.readStringUntil(',');
        String hdd_string = BTSerial.readStringUntil(',');
        String gpu_string = BTSerial.readStringUntil(',');
        String procs_string = BTSerial.readStringUntil('/');

        Serial.println(cpu_string);
        Serial.println(fan_string);
        Serial.println(ram_string);
        Serial.println(hdd_string);
        Serial.println(gpu_string);
        Serial.println(procs_string);

        // Add values we got to our arrays
        addToArray(cpu_string.toInt(), cpu);
        addToArray(fan_string.toInt(), fan);
        addToArray(ram_string.toInt(), ram);
        addToArray(hdd_string.toInt(), hdd);
        addToArray(gpu_string.toInt(), gpu);
        addToArray(procs_string.toInt(), procs);
    }
}
