#include <Arduino.h>
int btn0 = 6, btn1 = 7, btn2 = 8, buzzer = 9;
int led0 = 10, led1 = 11, led2 = 12;
int i, j, k, error = 0, num = -1;

void ledOn()
{
    //随机使一个LED亮
    num = rand() % 3;
    if (num == 0)
        digitalWrite(led0, HIGH);
    if (num == 1)
        digitalWrite(led1, HIGH);
    if (num == 2)
        digitalWrite(led2, HIGH);
}
void ledOff()
{
    digitalWrite(led0, LOW);
    digitalWrite(led1, LOW);
    digitalWrite(led2, LOW);
}

void warning()
{
    digitalWrite(buzzer, HIGH);
    delay(200);
    digitalWrite(buzzer, LOW);
    error++;
}

int judge()
{
    //判断对应的按键是否被按下，按键正确返回1，否则返回0
    while (num == 0)
    {
        if (digitalRead(btn0) == HIGH)
        {
            Serial.println("0 right");
            return 1;
        }
        else if (digitalRead(btn1) == HIGH || digitalRead(btn2) == HIGH)
        {
            error++;
            Serial.println("0 wrong");
            return 0;
        }
    }
    while (num == 1)
    {
        if (digitalRead(btn1) == HIGH)
        {
            Serial.println("1 right");
            return 1;
        }
        else if (digitalRead(btn0) == HIGH || digitalRead(btn2) == HIGH)
        {
            error++;
            Serial.println("1 wrong");
            return 0;
        }
    }
    while (num == 2)
    {
        if (digitalRead(btn2) == HIGH)
        {
            Serial.println("2 right");
            return 1;
        }
        else if (digitalRead(btn0) == HIGH || digitalRead(btn1) == HIGH)
        {
            error++;
            Serial.println("2 wrong");
            return 0;
        }
    }
    return -1;
}

void forever()
{
    while (1)
    {
        delay(1000);
    }
}

int task(int x)
{
    ledOn();
    delay(x);
    ledOff();
    delay(x);
    if (judge() == 0)
        warning();
    if (error >= 3)
    {
        for (k = 1; k <= 3; k++)
        {
            digitalWrite(buzzer, HIGH);
            delay(200);
            digitalWrite(buzzer, LOW);
            delay(200);
        }
        Serial.println("game over");
        return 0;
    }
    return 1;
}

void setup()
{
    Serial.begin(9600);
    pinMode(led0, OUTPUT);
    pinMode(led1, OUTPUT);
    pinMode(led2, OUTPUT);
    pinMode(buzzer, OUTPUT);
    pinMode(btn0, INPUT);
    pinMode(btn1, INPUT);
    pinMode(btn2, INPUT);
    for (i = 0; i < 3; i++)
    {
        digitalWrite(buzzer, HIGH);
        delay(200);
        digitalWrite(buzzer, LOW);
        delay(200);
    } //开始时蜂鸣器鸣叫三声
}

void loop()
{
    for (j = 0; j < 10; j++)
        if (task(500) == 0)
            forever();

    for (j = 0; j < 10; j++)
        if (task(400) == 0)
            forever();

    for (j = 0; j < 10; j++)
        if (task(300) == 0)
            forever();

    for (j = 0; j < 10; j++)
        if (task(200) == 0)
            forever();

    for (j = 0; j < 10; j++)
        if (task(100) == 0)
            forever();
    Serial.println("game over");
    forever();
}